diff -Naur newlib-1.19.0.orig/newlib/libc/search/extern.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/search/extern.h
--- newlib-1.19.0.orig/newlib/libc/search/extern.h	2002-06-20 21:51:31.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/search/extern.h	2011-05-17 07:25:06.780153559 +0200
@@ -43,7 +43,7 @@
 int	 __big_split(HTAB *, BUFHEAD *, BUFHEAD *, BUFHEAD *,
 		int, __uint32_t, SPLIT_RETURN *);
 int	 __buf_free(HTAB *, int, int);
-void	 __buf_init(HTAB *, int);
+void	 __buf_init(HTAB *, __uint32_t);
 __uint32_t	 __call_hash(HTAB *, char *, int);
 int	 __delpair(HTAB *, BUFHEAD *, int);
 int	 __expand_table(HTAB *);
diff -Naur newlib-1.19.0.orig/newlib/libc/search/hash_buf.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/search/hash_buf.c
--- newlib-1.19.0.orig/newlib/libc/search/hash_buf.c	2004-05-26 19:57:10.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/search/hash_buf.c	2011-05-17 07:25:06.781153575 +0200
@@ -118,7 +118,7 @@
 	int newpage;	/* If prev_bp set, indicates a new overflow page. */
 {
 	BUFHEAD *bp;
-	__uint32_t is_disk_mask;
+	ptrdiff_t is_disk_mask;
 	int is_disk, segment_ndx;
 	SEGMENT segp;
 
@@ -298,7 +298,7 @@
 extern void
 __buf_init(hashp, nbytes)
 	HTAB *hashp;
-	int nbytes;
+	__uint32_t nbytes;
 {
 	BUFHEAD *bfp;
 	int npages;
diff -Naur newlib-1.19.0.orig/newlib/libc/search/hash.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/search/hash.h
--- newlib-1.19.0.orig/newlib/libc/search/hash.h	2008-07-02 20:38:45.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/search/hash.h	2011-05-17 07:25:06.780153559 +0200
@@ -82,7 +82,7 @@
 
 /* Hash Table Information */
 typedef struct hashhdr {		/* Disk resident portion */
-	int		magic;		/* Magic NO for hash tables */
+	__uint32_t	magic;		/* Magic NO for hash tables */
 	int		version;	/* Version ID */
 	__uint32_t	lorder;		/* Byte Order */
 	int		bsize;		/* Bucket/Page Size */
@@ -97,7 +97,7 @@
 	int		high_mask;	/* Mask to modulo into entire table */
 	int		low_mask;	/* Mask to modulo into lower half of 
 					 * table */
-	int		ffactor;	/* Fill factor */
+	__uint32_t	ffactor;	/* Fill factor */
 	int		nkeys;		/* Number of keys in hash table */
 	int		hdrpages;	/* Size of table header */
 	int		h_charkey;	/* value of hash(CHARKEY) */
diff -Naur newlib-1.19.0.orig/newlib/libc/signal/Makefile.am newlib-1.19.0-rtems4.11-20110517/newlib/libc/signal/Makefile.am
--- newlib-1.19.0.orig/newlib/libc/signal/Makefile.am	2006-04-11 21:02:09.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/signal/Makefile.am	2011-05-17 07:25:06.781153575 +0200
@@ -4,7 +4,7 @@
 
 INCLUDES = $(NEWLIB_CFLAGS) $(CROSS_CFLAGS) $(TARGET_CFLAGS)
 
-LIB_SOURCES = raise.c signal.c
+LIB_SOURCES = psignal.c raise.c signal.c
 
 libsignal_la_LDFLAGS = -Xcompiler -nostdlib
 
@@ -21,7 +21,7 @@
 
 include $(srcdir)/../../Makefile.shared
 
-CHEWOUT_FILES = raise.def signal.def
+CHEWOUT_FILES = psignal.def raise.def signal.def
 
 SUFFIXES = .def
 
diff -Naur newlib-1.19.0.orig/newlib/libc/signal/psignal.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/signal/psignal.c
--- newlib-1.19.0.orig/newlib/libc/signal/psignal.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/signal/psignal.c	2011-05-17 07:25:06.781153575 +0200
@@ -0,0 +1,51 @@
+/* Copyright 2002, 2011 Red Hat Inc. */
+/*
+FUNCTION
+<<psignal>>---print a signal message on standard error
+
+INDEX
+	psignal
+
+ANSI_SYNOPSIS
+	#include <stdio.h>
+	void psignal(int <[signal]>, const char *<[prefix]>);
+
+TRAD_SYNOPSIS
+	#include <stdio.h>
+	void psignal(<[signal]>, <[prefix]>)
+	int <[signal]>;
+	const char *<[prefix]>;
+
+DESCRIPTION
+Use <<psignal>> to print (on standard error) a signal message
+corresponding to the value of the signal number <[signal]>.
+Unless you use <<NULL>> as the value of the argument <[prefix]>, the
+signal message will begin with the string at <[prefix]>, followed by a
+colon and a space (<<: >>). The remainder of the signal message is one
+of the strings described for <<strsignal>>.
+
+RETURNS
+<<psignal>> returns no result.
+
+PORTABILITY
+POSIX.1-2008 requires <<psignal>>, but the strings issued vary from one
+implementation to another.
+
+Supporting OS subroutines required: <<close>>, <<fstat>>, <<isatty>>,
+<<lseek>>, <<read>>, <<sbrk>>, <<write>>.
+*/
+
+#include <_ansi.h>
+#include <stdio.h>
+#include <string.h>
+
+_VOID
+_DEFUN(psignal, (sig, s),
+       int sig _AND
+       _CONST char *s)
+{
+  if (s != NULL && *s != '\0')
+    fprintf (stderr, "%s: %s\n", s, strsignal (sig));
+  else
+    fprintf (stderr, "%s\n", strsignal (sig));
+}
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/fclose.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fclose.c
--- newlib-1.19.0.orig/newlib/libc/stdio/fclose.c	2007-07-13 22:37:53.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fclose.c	2011-05-17 07:25:06.781153575 +0200
@@ -74,8 +74,6 @@
   if (fp == NULL)
     return (0);			/* on NULL */
 
-  __sfp_lock_acquire ();
-
   CHECK_INIT (rptr, fp);
 
   _flockfile (fp);
@@ -83,7 +81,6 @@
   if (fp->_flags == 0)		/* not open! */
     {
       _funlockfile (fp);
-      __sfp_lock_release ();
       return (0);
     }
   /* Unconditionally flush to allow special handling for seekable read
@@ -98,6 +95,7 @@
     FREEUB (rptr, fp);
   if (HASLB (fp))
     FREELB (rptr, fp);
+  __sfp_lock_acquire ();
   fp->_flags = 0;		/* release this FILE for reuse */
   _funlockfile (fp);
 #ifndef __SINGLE_THREAD__
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/fflush.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fflush.c
--- newlib-1.19.0.orig/newlib/libc/stdio/fflush.c	2009-10-30 09:26:41.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fflush.c	2011-05-17 07:25:06.782153592 +0200
@@ -67,37 +67,16 @@
 
 /* Flush a single file, or (if fp is NULL) all files.  */
 
+/* Core function which does not lock file pointer.  This gets called
+   directly from __srefill. */
 int
-_DEFUN(_fflush_r, (ptr, fp),
+_DEFUN(__sflush_r, (ptr, fp),
        struct _reent *ptr _AND
        register FILE * fp)
 {
   register unsigned char *p;
   register int n, t;
 
-#ifdef _REENT_SMALL
-  /* For REENT_SMALL platforms, it is possible we are being
-     called for the first time on a std stream.  This std
-     stream can belong to a reentrant struct that is not
-     _REENT.  If CHECK_INIT gets called below based on _REENT,
-     we will end up changing said file pointers to the equivalent
-     std stream off of _REENT.  This causes unexpected behavior if
-     there is any data to flush on the _REENT std stream.  There
-     are two alternatives to fix this:  1) make a reentrant fflush
-     or 2) simply recognize that this file has nothing to flush
-     and return immediately before performing a CHECK_INIT.  Choice
-     2 is implemented here due to its simplicity.  */
-  if (fp->_bf._base == NULL)
-    return 0;
-#endif /* _REENT_SMALL  */
-
-  CHECK_INIT (ptr, fp);
-
-  if (!fp->_flags)
-    return 0;
-
-  _flockfile (fp);
-
   t = fp->_flags;
   if ((t & __SWR) == 0)
     {
@@ -150,7 +129,6 @@
 		    }
 		  else
 		    fp->_flags |= __SERR;
-		  _funlockfile (fp);
 		  return result;
 		}
             }
@@ -186,17 +164,14 @@
 	  else
 	    {
 	      fp->_flags |= __SERR;
-	      _funlockfile (fp);
 	      return EOF;
 	    }
 	}
-      _funlockfile (fp);
       return 0;
     }
   if ((p = fp->_bf._base) == NULL)
     {
       /* Nothing to flush.  */
-      _funlockfile (fp);
       return 0;
     }
   n = fp->_p - p;		/* write this much */
@@ -215,16 +190,48 @@
       if (t <= 0)
 	{
           fp->_flags |= __SERR;
-          _funlockfile (fp);
           return EOF;
 	}
       p += t;
       n -= t;
     }
-  _funlockfile (fp);
   return 0;
 }
 
+int
+_DEFUN(_fflush_r, (ptr, fp),
+       struct _reent *ptr _AND
+       register FILE * fp)
+{
+  int ret;
+
+#ifdef _REENT_SMALL
+  /* For REENT_SMALL platforms, it is possible we are being
+     called for the first time on a std stream.  This std
+     stream can belong to a reentrant struct that is not
+     _REENT.  If CHECK_INIT gets called below based on _REENT,
+     we will end up changing said file pointers to the equivalent
+     std stream off of _REENT.  This causes unexpected behavior if
+     there is any data to flush on the _REENT std stream.  There
+     are two alternatives to fix this:  1) make a reentrant fflush
+     or 2) simply recognize that this file has nothing to flush
+     and return immediately before performing a CHECK_INIT.  Choice
+     2 is implemented here due to its simplicity.  */
+  if (fp->_bf._base == NULL)
+    return 0;
+#endif /* _REENT_SMALL  */
+
+  CHECK_INIT (ptr, fp);
+
+  if (!fp->_flags)
+    return 0;
+
+  _flockfile (fp);
+  ret = __sflush_r (ptr, fp);
+  _funlockfile (fp);
+  return ret;
+}
+
 #ifndef _REENT_ONLY
 
 int
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/fgetc.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fgetc.c
--- newlib-1.19.0.orig/newlib/libc/stdio/fgetc.c	2009-04-25 00:52:51.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fgetc.c	2011-05-17 07:25:06.783153609 +0200
@@ -93,11 +93,9 @@
 #if !defined(PREFER_SIZE_OVER_SPEED) && !defined(__OPTIMIZE_SIZE__)
   int result;
   CHECK_INIT(_REENT, fp);
-  __sfp_lock_acquire ();
   _flockfile (fp);
   result = __sgetc_r (_REENT, fp);
   _funlockfile (fp);
-  __sfp_lock_release ();
   return result;
 #else
   return _fgetc_r (_REENT, fp);
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/fgets.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fgets.c
--- newlib-1.19.0.orig/newlib/libc/stdio/fgets.c	2009-04-25 00:52:51.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fgets.c	2011-05-17 07:25:06.783153609 +0200
@@ -98,7 +98,6 @@
 
   CHECK_INIT(ptr, fp);
 
-  __sfp_lock_acquire ();
   _flockfile (fp);
 #ifdef __SCLE
   if (fp->_flags & __SCLE)
@@ -114,12 +113,10 @@
       if (c == EOF && s == buf)
         {
           _funlockfile (fp);
-	  __sfp_lock_release ();
           return NULL;
         }
       *s = 0;
       _funlockfile (fp);
-      __sfp_lock_release ();
       return buf;
     }
 #endif
@@ -138,7 +135,6 @@
 	      if (s == buf)
                 {
                   _funlockfile (fp);
-		  __sfp_lock_release ();
                   return 0;
                 }
 	      break;
@@ -164,7 +160,6 @@
 	  _CAST_VOID memcpy ((_PTR) s, (_PTR) p, len);
 	  s[len] = 0;
           _funlockfile (fp);
-	  __sfp_lock_release ();
 	  return (buf);
 	}
       fp->_r -= len;
@@ -175,7 +170,6 @@
   while ((n -= len) != 0);
   *s = 0;
   _funlockfile (fp);
-  __sfp_lock_release ();
   return buf;
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/fgetwc.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fgetwc.c
--- newlib-1.19.0.orig/newlib/libc/stdio/fgetwc.c	2009-04-25 00:52:52.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fgetwc.c	2011-05-17 07:25:06.783153609 +0200
@@ -164,12 +164,10 @@
 {
   wint_t r;
 
-  __sfp_lock_acquire ();
   _flockfile (fp);
   ORIENT(fp, 1);
   r = __fgetwc (ptr, fp);
   _funlockfile (fp);
-  __sfp_lock_release ();
   return r;
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/fgetws.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fgetws.c
--- newlib-1.19.0.orig/newlib/libc/stdio/fgetws.c	2009-04-25 00:52:52.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fgetws.c	2011-05-17 07:25:06.783153609 +0200
@@ -93,7 +93,6 @@
   const char *src;
   unsigned char *nl;
 
-  __sfp_lock_acquire ();
   _flockfile (fp);
   ORIENT (fp, 1);
 
@@ -144,12 +143,10 @@
     goto error;
   *wsp++ = L'\0';
   _funlockfile (fp);
-  __sfp_lock_release ();
   return ws;
 
 error:
   _funlockfile (fp);
-  __sfp_lock_release ();
   return NULL;
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/fmemopen.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fmemopen.c
--- newlib-1.19.0.orig/newlib/libc/stdio/fmemopen.c	2007-08-02 22:23:06.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fmemopen.c	2011-05-17 07:25:06.783153609 +0200
@@ -281,7 +281,7 @@
 
   if ((flags = __sflags (ptr, mode, &dummy)) == 0)
     return NULL;
-  if (!size || !(buf || flags & __SAPP))
+  if (!size || !(buf || flags & __SRW))
     {
       ptr->_errno = EINVAL;
       return NULL;
@@ -310,7 +310,7 @@
     {
       /* r+/w+/a+, and no buf: file starts empty.  */
       c->buf = (char *) (c + 1);
-      *(char *) buf = '\0';
+      c->buf[0] = '\0';
       c->pos = c->eof = 0;
       c->append = (flags & __SAPP) != 0;
     }
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/fread.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fread.c
--- newlib-1.19.0.orig/newlib/libc/stdio/fread.c	2009-04-25 00:52:52.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fread.c	2011-05-17 07:25:06.784153625 +0200
@@ -146,7 +146,6 @@
 
   CHECK_INIT(ptr, fp);
 
-  __sfp_lock_acquire ();
   _flockfile (fp);
   ORIENT (fp, -1);
   if (fp->_r < 0)
@@ -197,12 +196,10 @@
               if (fp->_flags & __SCLE)
 	        {
 	          _funlockfile (fp);
-		  __sfp_lock_release ();
 	          return crlf_r (ptr, fp, buf, total-resid, 1) / size;
 	        }
 #endif
 	      _funlockfile (fp);
-	      __sfp_lock_release ();
 	      return (total - resid) / size;
 	    }
 	}
@@ -224,12 +221,10 @@
 	      if (fp->_flags & __SCLE)
 		{
 		  _funlockfile (fp);
-		  __sfp_lock_release ();
 		  return crlf_r (ptr, fp, buf, total-resid, 1) / size;
 		}
 #endif
 	      _funlockfile (fp);
-	      __sfp_lock_release ();
 	      return (total - resid) / size;
 	    }
 	}
@@ -243,12 +238,10 @@
   if (fp->_flags & __SCLE)
     {
       _funlockfile (fp);
-      __sfp_lock_release ();
       return crlf_r(ptr, fp, buf, total, 0) / size;
     }
 #endif
   _funlockfile (fp);
-  __sfp_lock_release ();
   return count;
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/freopen.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/freopen.c
--- newlib-1.19.0.orig/newlib/libc/stdio/freopen.c	2008-12-12 16:45:19.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/freopen.c	2011-05-17 07:25:06.784153625 +0200
@@ -98,8 +98,6 @@
   int flags, oflags;
   int e = 0;
 
-  __sfp_lock_acquire ();
-
   CHECK_INIT (ptr, fp);
 
   _flockfile (fp);
@@ -108,7 +106,6 @@
     {
       _funlockfile (fp);
       _fclose_r (ptr, fp);
-      __sfp_lock_release ();
       return NULL;
     }
 
@@ -208,6 +205,7 @@
 
   if (f < 0)
     {				/* did not get it after all */
+      __sfp_lock_acquire ();
       fp->_flags = 0;		/* set it free */
       ptr->_errno = e;		/* restore in case _close clobbered */
       _funlockfile (fp);
@@ -232,7 +230,6 @@
 #endif
 
   _funlockfile (fp);
-  __sfp_lock_release ();
   return fp;
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/fseek.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fseek.c
--- newlib-1.19.0.orig/newlib/libc/stdio/fseek.c	2009-12-17 20:43:43.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fseek.c	2011-05-17 07:25:06.784153625 +0200
@@ -138,7 +138,6 @@
 
   CHECK_INIT (ptr, fp);
 
-  __sfp_lock_acquire ();
   _flockfile (fp);
 
   /* If we've been doing some writing, and we're in append mode
@@ -156,7 +155,6 @@
     {
       ptr->_errno = ESPIPE;	/* ??? */
       _funlockfile (fp);
-      __sfp_lock_release ();
       return EOF;
     }
 
@@ -182,7 +180,6 @@
 	  if (curoff == -1L)
 	    {
 	      _funlockfile (fp);
-	      __sfp_lock_release ();
 	      return EOF;
 	    }
 	}
@@ -208,7 +205,6 @@
     default:
       ptr->_errno = EINVAL;
       _funlockfile (fp);
-      __sfp_lock_release ();
       return (EOF);
     }
 
@@ -268,7 +264,6 @@
     {
       ptr->_errno = EOVERFLOW;
       _funlockfile (fp);
-      __sfp_lock_release ();
       return EOF;
     }
 
@@ -325,7 +320,6 @@
       fp->_flags &= ~__SEOF;
       memset (&fp->_mbstate, 0, sizeof (_mbstate_t));
       _funlockfile (fp);
-      __sfp_lock_release ();
       return 0;
     }
 
@@ -356,7 +350,6 @@
     }
   memset (&fp->_mbstate, 0, sizeof (_mbstate_t));
   _funlockfile (fp);
-  __sfp_lock_release ();
   return 0;
 
   /*
@@ -369,7 +362,6 @@
       || seekfn (ptr, fp->_cookie, offset, whence) == POS_ERR)
     {
       _funlockfile (fp);
-      __sfp_lock_release ();
       return EOF;
     }
   /* success: clear EOF indicator and discard ungetc() data */
@@ -388,7 +380,6 @@
   fp->_flags &= ~__SNPT;
   memset (&fp->_mbstate, 0, sizeof (_mbstate_t));
   _funlockfile (fp);
-  __sfp_lock_release ();
   return 0;
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/fwalk.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fwalk.c
--- newlib-1.19.0.orig/newlib/libc/stdio/fwalk.c	2009-01-12 23:19:11.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/fwalk.c	2011-05-17 07:25:06.784153625 +0200
@@ -27,8 +27,8 @@
 #include <errno.h>
 #include "local.h"
 
-static int
-_DEFUN(__fwalk, (ptr, function),
+int
+_DEFUN(_fwalk, (ptr, function),
        struct _reent *ptr _AND
        register int (*function) (FILE *))
 {
@@ -36,11 +36,19 @@
   register int n, ret = 0;
   register struct _glue *g;
 
+  /*
+   * It should be safe to walk the list without locking it;
+   * new nodes are only added to the end and none are ever
+   * removed.
+   *
+   * Avoid locking this list while walking it or else you will
+   * introduce a potential deadlock in [at least] refill.c.
+   */
   for (g = &ptr->__sglue; g != NULL; g = g->_next)
     for (fp = g->_iobs, n = g->_niobs; --n >= 0; fp++)
       if (fp->_flags != 0)
         {
-          if (fp->_flags != 0 && fp->_file != -1)
+          if (fp->_flags != 0 && fp->_flags != 1 && fp->_file != -1)
             ret |= (*function) (fp);
         }
 
@@ -49,8 +57,8 @@
 
 /* Special version of __fwalk where the function pointer is a reentrant
    I/O function (e.g. _fclose_r).  */
-static int
-_DEFUN(__fwalk_reent, (ptr, reent_function),
+int
+_DEFUN(_fwalk_reent, (ptr, reent_function),
        struct _reent *ptr _AND
        register int (*reent_function) (struct _reent *, FILE *))
 {
@@ -58,51 +66,21 @@
   register int n, ret = 0;
   register struct _glue *g;
 
+  /*
+   * It should be safe to walk the list without locking it;
+   * new nodes are only added to the end and none are ever
+   * removed.
+   *
+   * Avoid locking this list while walking it or else you will
+   * introduce a potential deadlock in [at least] refill.c.
+   */
   for (g = &ptr->__sglue; g != NULL; g = g->_next)
     for (fp = g->_iobs, n = g->_niobs; --n >= 0; fp++)
       if (fp->_flags != 0)
         {
-          if (fp->_flags != 0 && fp->_file != -1)
+          if (fp->_flags != 0 && fp->_flags != 1 && fp->_file != -1)
             ret |= (*reent_function) (ptr, fp);
         }
 
   return ret;
 }
-
-int
-_DEFUN(_fwalk, (ptr, function),
-       struct _reent *ptr _AND
-       register int (*function)(FILE *))
-{
-  register int ret = 0;
-
-  __sfp_lock_acquire ();
-
-  /* Must traverse given list for streams.  Note that _GLOBAL_REENT
-     only walked once in exit().  */
-  ret |= __fwalk (ptr, function);
-
-  __sfp_lock_release ();
-
-  return ret;
-}
-
-/* Special version of _fwalk which handles a function pointer to a
-   reentrant I/O function (e.g. _fclose_r).  */
-int
-_DEFUN(_fwalk_reent, (ptr, reent_function),
-       struct _reent *ptr _AND
-       register int (*reent_function) (struct _reent *, FILE *))
-{
-  register int ret = 0;
-
-  __sfp_lock_acquire ();
-
-  /* Must traverse given list for streams.  Note that _GLOBAL_REENT
-     only walked once in exit().  */
-  ret |= __fwalk_reent (ptr, reent_function);
-
-  __sfp_lock_release ();
-
-  return ret;
-}
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/getc.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/getc.c
--- newlib-1.19.0.orig/newlib/libc/stdio/getc.c	2009-04-25 00:52:52.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/getc.c	2011-05-17 07:25:06.784153625 +0200
@@ -92,11 +92,9 @@
 {
   int result;
   CHECK_INIT (ptr, fp);
-  __sfp_lock_acquire ();
   _flockfile (fp);
   result = __sgetc_r (ptr, fp);
   _funlockfile (fp);
-  __sfp_lock_release ();
   return result;
 }
 
@@ -108,11 +106,9 @@
 {
   int result;
   CHECK_INIT (_REENT, fp);
-  __sfp_lock_acquire ();
   _flockfile (fp);
   result = __sgetc_r (_REENT, fp);
   _funlockfile (fp);
-  __sfp_lock_release ();
   return result;
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/getdelim.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/getdelim.c
--- newlib-1.19.0.orig/newlib/libc/stdio/getdelim.c	2009-04-25 00:52:52.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/getdelim.c	2011-05-17 07:25:06.784153625 +0200
@@ -81,7 +81,6 @@
 
   CHECK_INIT (_REENT, fp);
 
-  __sfp_lock_acquire ();
   _flockfile (fp);
 
   numbytes = *n;
@@ -131,7 +130,6 @@
     }
 
   _funlockfile (fp);
-  __sfp_lock_release ();
 
   /* if no input data, return failure */
   if (ptr == buf)
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/gets.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/gets.c
--- newlib-1.19.0.orig/newlib/libc/stdio/gets.c	2009-04-25 00:52:52.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/gets.c	2011-05-17 07:25:06.785153640 +0200
@@ -79,14 +79,12 @@
   register int c;
   register char *s = buf;
 
-  __sfp_lock_acquire ();
   _flockfile (stdin);
   while ((c = __sgetc_r (ptr, stdin)) != '\n')
     if (c == EOF)
       if (s == buf)
 	{
 	  _funlockfile (stdin);
-	  __sfp_lock_release ();
 	  return NULL;
 	}
       else
@@ -95,7 +93,6 @@
       *s++ = c;
   *s = 0;
   _funlockfile (stdin);
-  __sfp_lock_release ();
   return buf;
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/local.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/local.h
--- newlib-1.19.0.orig/newlib/libc/stdio/local.h	2009-04-22 10:30:03.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/local.h	2011-05-17 07:25:06.785153640 +0200
@@ -54,6 +54,7 @@
 				  va_list));
 extern FILE  *_EXFUN(__sfp,(struct _reent *));
 extern int    _EXFUN(__sflags,(struct _reent *,_CONST char*, int*));
+extern int    _EXFUN(__sflush_r,(struct _reent *,FILE *));
 extern int    _EXFUN(__srefill_r,(struct _reent *,FILE *));
 extern _READ_WRITE_RETURN_TYPE _EXFUN(__sread,(struct _reent *, void *, char *,
 					       int));
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/open_memstream.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/open_memstream.c
--- newlib-1.19.0.orig/newlib/libc/stdio/open_memstream.c	2009-02-25 05:00:05.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/open_memstream.c	2011-05-17 07:25:06.785153640 +0200
@@ -330,8 +330,10 @@
     c->max *= sizeof(wchar_t);
   if (c->max < 64)
     c->max = 64;
-  else if (c->max > 64 * 1024)
-    c->max = 64 * 1024;
+#if (SIZE_MAX >= 0x10000)
+  else if (c->max > 0x10000)
+    c->max = 0x10000;
+#endif
   *size = 0;
   *buf = _malloc_r (ptr, c->max);
   if (!*buf)
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/refill.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/refill.c
--- newlib-1.19.0.orig/newlib/libc/stdio/refill.c	2008-12-11 00:43:12.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/refill.c	2011-05-17 07:25:06.785153640 +0200
@@ -102,9 +102,19 @@
    * flush all line buffered output files, per the ANSI C
    * standard.
    */
-
   if (fp->_flags & (__SLBF | __SNBF))
-    _CAST_VOID _fwalk (_GLOBAL_REENT, lflush);
+    {
+      /* Ignore this file in _fwalk to avoid potential deadlock. */
+      short orig_flags = fp->_flags;
+      fp->_flags = 1;
+      _CAST_VOID _fwalk (_GLOBAL_REENT, lflush);
+      fp->_flags = orig_flags;
+
+      /* Now flush this file without locking it. */
+      if ((fp->_flags & (__SLBF|__SWR)) == (__SLBF|__SWR))
+	__sflush_r (ptr, fp);
+    }
+
   fp->_p = fp->_bf._base;
   fp->_r = fp->_read (ptr, fp->_cookie, (char *) fp->_p, fp->_bf._size);
 #ifndef __CYGWIN__
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/tmpnam.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/tmpnam.c
--- newlib-1.19.0.orig/newlib/libc/stdio/tmpnam.c	2004-04-23 22:01:55.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/tmpnam.c	2011-05-17 07:25:06.785153640 +0200
@@ -94,6 +94,7 @@
 #include <_ansi.h>
 #include <reent.h>
 #include <stdio.h>
+#include <stdint.h>
 #include <stdlib.h>
 #include <string.h>
 #include <fcntl.h>
@@ -109,7 +110,7 @@
        char *result       _AND
        _CONST char *part1 _AND
        _CONST char *part2 _AND
-       int part3          _AND
+       intptr_t part3     _AND
        int *part4)
 {
   /*  Generate the filename and make sure that there isn't one called
@@ -183,7 +184,7 @@
   if (filename)
     {
       if (! worker (p, filename, dir, prefix,
-		    _getpid_r (p) ^ (int) (_POINTER_INT) p, &p->_inc))
+		    _getpid_r (p) ^ (intptr_t) p, &p->_inc))
 	return NULL;
     }
   return filename;
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/vfscanf.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/vfscanf.c
--- newlib-1.19.0.orig/newlib/libc/stdio/vfscanf.c	2010-01-20 00:16:45.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/vfscanf.c	2011-05-17 07:25:06.786153654 +0200
@@ -494,7 +494,6 @@
 # define GET_ARG(n, ap, type) (va_arg (ap, type))
 #endif
 
-  __sfp_lock_acquire ();
   _flockfile (fp);
 
   ORIENT (fp, -1);
@@ -795,7 +794,6 @@
 	   */
 	case '\0':		/* compat */
 	  _funlockfile (fp);
-	  __sfp_lock_release ();
 	  return EOF;
 
 	default:		/* compat */
@@ -1596,13 +1594,11 @@
      invalid format string), return EOF if no matches yet, else number
      of matches made prior to failure.  */
   _funlockfile (fp);
-  __sfp_lock_release ();
   return nassigned && !(fp->_flags & __SERR) ? nassigned : EOF;
 match_failure:
 all_done:
   /* Return number of matches, which can be 0 on match failure.  */
   _funlockfile (fp);
-  __sfp_lock_release ();
   return nassigned;
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio/vfwscanf.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/vfwscanf.c
--- newlib-1.19.0.orig/newlib/libc/stdio/vfwscanf.c	2009-03-11 12:53:22.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio/vfwscanf.c	2011-05-17 07:25:06.786153654 +0200
@@ -434,7 +434,6 @@
 # define GET_ARG(n, ap, type) (va_arg (ap, type))
 #endif
 
-  __sfp_lock_acquire ();
   _flockfile (fp);
 
   ORIENT (fp, 1);
@@ -714,7 +713,6 @@
 	   */
 	case L'\0':		/* compat */
 	  _funlockfile (fp);
-	  __sfp_lock_release ();
 	  return EOF;
 
 	default:		/* compat */
@@ -1443,13 +1441,11 @@
      invalid format string), return EOF if no matches yet, else number
      of matches made prior to failure.  */
   _funlockfile (fp);
-  __sfp_lock_release ();
   return nassigned && !(fp->_flags & __SERR) ? nassigned : EOF;
 match_failure:
 all_done:
   /* Return number of matches, which can be 0 on match failure.  */
   _funlockfile (fp);
-  __sfp_lock_release ();
   return nassigned;
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdio64/freopen64.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio64/freopen64.c
--- newlib-1.19.0.orig/newlib/libc/stdio64/freopen64.c	2007-07-13 22:37:53.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdio64/freopen64.c	2011-05-17 07:25:06.786153654 +0200
@@ -97,7 +97,6 @@
   int flags, oflags;
   int e = 0;
 
-  __sfp_lock_acquire ();
 
   CHECK_INIT (ptr, fp);
 
@@ -107,7 +106,6 @@
     {
       _funlockfile(fp);
       _fclose_r (ptr, fp);
-      __sfp_lock_release ();
       return NULL;
     }
 
@@ -204,6 +202,7 @@
 
   if (f < 0)
     {				/* did not get it after all */
+      __sfp_lock_acquire ();
       fp->_flags = 0;		/* set it free */
       ptr->_errno = e;		/* restore in case _close clobbered */
       _funlockfile(fp);
@@ -231,7 +230,6 @@
   fp->_flags |= __SL64;
 
   _funlockfile(fp);
-  __sfp_lock_release ();
   return fp;
 }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdlib/atof.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdlib/atof.c
--- newlib-1.19.0.orig/newlib/libc/stdlib/atof.c	2003-10-20 20:46:37.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdlib/atof.c	2011-05-17 07:25:06.787153668 +0200
@@ -1,6 +1,6 @@
 /*
 FUNCTION
-   <<atof>>, <<atoff>>---string to double or float
+   <<atof>> ---string to double
 
 INDEX
 	atof
@@ -10,19 +10,14 @@
 ANSI_SYNOPSIS
 	#include <stdlib.h>
         double atof(const char *<[s]>);
-        float atoff(const char *<[s]>);
 
 TRAD_SYNOPSIS
 	#include <stdlib.h>
         double atof(<[s]>)
         char *<[s]>;
 
-        float atoff(<[s]>)
-        char *<[s]>;
-
 DESCRIPTION
 <<atof>> converts the initial portion of a string to a <<double>>.
-<<atoff>> converts the initial portion of a string to a <<float>>.
 
 The functions parse the character string <[s]>,
 locating a substring which can be converted to a floating-point
@@ -36,7 +31,6 @@
 something other than <<+>>, <<->>, <<.>>, or a digit.
 
 <<atof(<[s]>)>> is implemented as <<strtod(<[s]>, NULL)>>.
-<<atoff(<[s]>)>> is implemented as <<strtof(<[s]>, NULL)>>.
 
 RETURNS
 <<atof>> returns the converted substring value, if any, as a
@@ -47,12 +41,9 @@
 If the correct value would cause underflow, <<0.0>> is returned
 and <<ERANGE>> is stored in <<errno>>.
 
-<<atoff>> obeys the same rules as <<atof>>, except that it
-returns a <<float>>.
-
 PORTABILITY
-<<atof>> is ANSI C. <<atof>>, <<atoi>>, and <<atol>> are subsumed by <<strod>>
-and <<strol>>, but are used extensively in existing code. These functions are
+<<atof>> is ANSI C. <<atof>>, <<atoi>>, and <<atol>> are subsumed by <<strtod>>
+and <<strtol>>, but are used extensively in existing code. These functions are
 less reliable, but may be faster if the argument is verified to be in a valid
 range.
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdlib/Makefile.am newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdlib/Makefile.am
--- newlib-1.19.0.orig/newlib/libc/stdlib/Makefile.am	2009-04-16 20:24:35.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdlib/Makefile.am	2011-05-17 07:25:06.787153668 +0200
@@ -16,7 +16,6 @@
 	assert.c  	\
 	atexit.c	\
 	atof.c 		\
-	atoff.c		\
 	atoi.c  	\
 	atol.c		\
 	calloc.c	\
diff -Naur newlib-1.19.0.orig/newlib/libc/stdlib/putenv_r.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdlib/putenv_r.c
--- newlib-1.19.0.orig/newlib/libc/stdlib/putenv_r.c	2004-11-24 23:34:14.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdlib/putenv_r.c	2011-05-17 07:25:06.788153682 +0200
@@ -24,6 +24,7 @@
 #include <reent.h>
 #include <stdlib.h>
 #include <string.h>
+#include <strings.h>
 
 #include "envlock.h"
 
diff -Naur newlib-1.19.0.orig/newlib/libc/stdlib/strtod.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdlib/strtod.c
--- newlib-1.19.0.orig/newlib/libc/stdlib/strtod.c	2010-12-07 22:26:45.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/stdlib/strtod.c	2011-05-17 07:25:06.788153682 +0200
@@ -309,8 +309,7 @@
         }
 	nd0 = nd;
 	if (strncmp (s, _localeconv_r (ptr)->decimal_point,
-		     strlen (_localeconv_r (ptr)->decimal_point)) == 0)
-		{
+		     strlen (_localeconv_r (ptr)->decimal_point)) == 0) {
 		decpt = 1;
 		c = *(s += strlen (_localeconv_r (ptr)->decimal_point));
 		if (!nd) {
@@ -328,25 +327,28 @@
  have_dig:
 			nz++;
 			if (c -= '0') {
-				nf += nz;
 				for(i = 1; i < nz; i++) {
-					if (nd++ <= DBL_DIG + 1) {
-						if (nd < 10)
+					if (nd <= DBL_DIG + 1) {
+						if (nd + i < 10)
 							y *= 10;
 						else
 							z *= 10;
 					}
 				}
-				if (nd++ <= DBL_DIG + 1) {
-					if (nd < 10)
+				if (nd <= DBL_DIG + 1) {
+					if (nd + i < 10)
 						y = 10*y + c;
 					else
 						z = 10*z + c;
 				}
-				nz = 0;
+				if (nd <= DBL_DIG + 1) {
+					nf += nz;
+					nd += nz;
 				}
+				nz = 0;
 			}
 		}
+	}
  dig_done:
 	e = 0;
 	if (c == 'e' || c == 'E') {
